#pragma once

#include <amdis/linearalgebra/LinearSolver.hpp>
#include <amdis/linearalgebra/SolverInfo.hpp>

#if HAVE_MTL

#include <amdis/linearalgebra/mtl/Constraints.hpp>
#include <amdis/linearalgebra/mtl/DOFMatrix.hpp>
#include <amdis/linearalgebra/mtl/DOFVector.hpp>
#include <amdis/linearalgebra/mtl/ITL_Solver.hpp>
#include <amdis/linearalgebra/mtl/ITL_Preconditioner.hpp>
#include <amdis/linearalgebra/mtl/Traits.hpp>

#elif HAVE_EIGEN

#include <amdis/linearalgebra/eigen/Constraints.hpp>
#include <amdis/linearalgebra/eigen/DOFMatrix.hpp>
#include <amdis/linearalgebra/eigen/DOFVector.hpp>
#include <amdis/linearalgebra/eigen/SolverCreator.hpp>
#include <amdis/linearalgebra/eigen/Traits.hpp>

#else // ISTL

#include <amdis/linearalgebra/istl/Constraints.hpp>
#include <amdis/linearalgebra/istl/DOFMatrix.hpp>
#include <amdis/linearalgebra/istl/DOFVector.hpp>
#include <amdis/linearalgebra/istl/ISTL_Solver.hpp>
#include <amdis/linearalgebra/istl/ISTL_Preconditioner.hpp>
#include <amdis/linearalgebra/istl/Traits.hpp>

#endif